"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createSubsetPlugin = void 0;
const createSubsetPlugin = (allowedNodeTypes = []) => {
    return ({ types: t }) => {
        // slice because babel throws an strange error here related to symbols
        const babelTypes = t.TYPES.slice(0, t.TYPES.length - 12);
        const deprecatedTypes = t.DEPRECATED_KEYS;
        const visitor = babelTypes.reduce((visitor, _type) => {
            if (typeof _type === 'string'
                && !deprecatedTypes[_type]
                && allowedNodeTypes.indexOf(_type) === -1) {
                visitor[_type] = (path) => {
                    throw path.buildCodeFrameError(`${_type} not allowed`);
                };
            }
            return visitor;
        }, {});
        return {
            visitor,
        };
    };
};
exports.createSubsetPlugin = createSubsetPlugin;
//# sourceMappingURL=plugin-subset.js.map