interface RuntimeConfig {
    timeout: number;
    syncTimeout: number;
    memoryLimit: number;
}
export declare class Runtime {
    private config;
    private beginTimestamp;
    private error;
    private lastAsyncCheckTimestamp;
    private lastCheck;
    private memorySize;
    private sizeCache;
    constructor(config: Partial<RuntimeConfig>);
    private throwTimeoutError;
    private throwMemoryLimitError;
    checkSync(): void;
    checkAsync(): Promise<unknown>;
    sizeOf(value: any): number;
    alloc(newAlloc: any, oldAlloc?: any, container?: any): void;
    captureLazyValue(value: any): any;
    createProxy(obj: any): any;
    createArr(arr: any[]): any;
    createObj(obj: any): any;
    getProp(obj: any, prop: any): any;
    callProp(obj: any, prop: any, ...args: any[]): any;
    setProp(obj: any, prop: any, value: any, operator: string): any;
    computedProp(prop: string): string | undefined;
    awaitPromise(promise: Promise<any>): Promise<any>;
}
export declare const createRuntime: (config: Partial<RuntimeConfig>) => Runtime;
export {};
