"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.extractTypes = void 0;
const babel = __importStar(require("@babel/core"));
const extractTypes = (src) => {
    const typesList = [];
    babel.transform(src, {
        plugins: [typeCollectorPlugin(typesList)]
    });
    return Array.from(new Set(typesList));
};
exports.extractTypes = extractTypes;
const typeCollectorPlugin = (typesList = []) => {
    return ({ types: t }) => {
        // slice because babel throws an strange error here related to symbols
        const babelTypes = t.TYPES.slice(0, t.TYPES.length - 12);
        const deprecatedTypes = t.DEPRECATED_KEYS;
        const visitor = babelTypes.reduce((visitor, _type) => {
            if (typeof _type === 'string' && !deprecatedTypes[_type]) {
                visitor[_type] = () => {
                    typesList.push(_type);
                };
            }
            return visitor;
        }, {});
        return {
            visitor,
        };
    };
};
//# sourceMappingURL=types-extractor.js.map