interface Client {
    request(source: string, args: any[]): any;
}
export declare type SourceLocation = string;
export interface RemoteFunction extends Function {
    (...args: any[]): any;
    isRemoteFunction?: boolean;
    client?: Client;
    source?: string;
    bound?: boolean;
    sourceLoc?: SourceLocation;
}
export interface BoundRemoteFunction extends Function {
    remoteFunction: RemoteFunction;
}
export interface Func {
    <T extends Function>(fn: T): T;
    (tsa: TemplateStringsArray): RemoteFunction;
    (str: string): RemoteFunction;
    <T extends Function>(client: Client, fn: T): (T & BoundRemoteFunction);
    (client: Client, tsa: TemplateStringsArray): RemoteFunction;
    (client: Client, str: string): RemoteFunction;
}
/** Create a new remote function */
export declare const func: Func;
/** Bind a remote function to a client */
export declare function bind<T>(client: Client, serviceName: string): T;
export declare function bind<T>(client: Client, remoteFunction: T & RemoteFunction): T & BoundRemoteFunction;
export {};
