/** create a JSON stream parser */
export declare const createParser: <T>(options: Partial<{
    /** Stream chunk delimiter \n by default */
    delimiter: string;
    /** Executed on data chunk is successfully parsed */
    onData: (data: T, src: string) => void;
    /** Executed on data chunk fails on parse */
    onError: (error: Error, buf: string) => void;
    /** Executed when the parser is closed */
    onClose: (buffer: string) => void;
}>) => {
    /** Write JSON chunk to parse */
    write(partial: string): void;
    /** Close parser */
    close(): void;
};
/** create a JSON stream stringifier */
export declare const createStringifier: <T>(options: Partial<{
    /** Stream chunk delimiter \n by default */
    delimiter: string;
    /** Executed on data is successfully stringified */
    onData: (src: string, data: T) => void;
    /** Executed if fails on stringify */
    onError: (error: Error, data: T) => void;
    /** Executed when the stringifier is closed */
    onClose: () => void;
}>) => {
    /** Write object to stringify */
    write(data: T): void;
    /** Close stringifier */
    close(): void;
};
