"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MemoryLimitError = exports.TimeoutError = exports.EvalError = exports.ErrorType = void 0;
var ErrorType;
(function (ErrorType) {
    ErrorType[ErrorType["EVAL"] = 0] = "EVAL";
    ErrorType[ErrorType["RUNTIME"] = 1] = "RUNTIME";
    ErrorType[ErrorType["TIMEOUT"] = 2] = "TIMEOUT";
    ErrorType[ErrorType["MEMORY_LIMIT"] = 3] = "MEMORY_LIMIT";
})(ErrorType = exports.ErrorType || (exports.ErrorType = {}));
class EvalError extends Error {
    constructor() {
        super(...arguments);
        this.errorType = ErrorType.EVAL;
    }
}
exports.EvalError = EvalError;
class TimeoutError extends Error {
    constructor() {
        super(...arguments);
        this.errorType = ErrorType.TIMEOUT;
    }
}
exports.TimeoutError = TimeoutError;
class MemoryLimitError extends Error {
    constructor() {
        super(...arguments);
        this.errorType = ErrorType.MEMORY_LIMIT;
    }
}
exports.MemoryLimitError = MemoryLimitError;
//# sourceMappingURL=error.js.map