import { Engine } from './engine';
import { SourceLocation } from '../client';
export interface RequestContext {
    request: any;
    response: string;
    source: string;
    args: any[];
    sourceLoc: SourceLocation;
}
export interface HttpHandlerInterface {
    engine?: Engine;
    initialContext?: Partial<RequestContext> & any;
    getQueryParam(key: string): any;
    getMethod(): string | void;
    getBody(): string | void;
    getHeader(name: string): string | void;
    setHeader(name: string, value: string): void;
    setStatusCode(statusCode: number): void;
    write(data: any): void;
    end(): void;
}
/** Generic HTTP handler, adaptable by providing handler interface */
export declare const handleHttpRequest: (iface: HttpHandlerInterface) => Promise<void>;
