"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createRpcCommand = exports.parseRpcCommand = exports.isRpcCommand = void 0;
var rpcKeyworkd = '@rpc';
var rpcTargetSeparator = '.';
var isRpcCommand = function (source) {
    return source.indexOf(rpcKeyworkd) === 0;
};
exports.isRpcCommand = isRpcCommand;
/** Parse rpc command */
var parseRpcCommand = function (rpcCommandStr) {
    var target = rpcCommandStr.substring(rpcKeyworkd.length).trim();
    var splitted = target.split(rpcTargetSeparator);
    return {
        service: splitted[0],
        method: splitted[1],
    };
};
exports.parseRpcCommand = parseRpcCommand;
/** Create rpc command */
var createRpcCommand = function (service, method) {
    return "".concat(rpcKeyworkd, " ").concat(service).concat(rpcTargetSeparator).concat(method);
};
exports.createRpcCommand = createRpcCommand;
//# sourceMappingURL=rpc.js.map