import { DeepClone } from './util';
/** Utility to type endpoint results */
export declare type Result<T> = DeepClone<T>;
export declare type AsyncResult<T> = Promise<Result<T>>;
export declare type ServiceBaseContext = {
    log?: (...args: any[]) => any;
    [prop: string]: any;
};
export declare const AsyncResult: PromiseConstructor;
export interface Services {
    [serviceName: string]: {
        [endpointName: string]: (...args: any[]) => any;
    };
}
/** Create a service */
export declare const createService: <Ctx extends unknown, ServiceDef>(serviceFactory: (ctx: Ctx) => ServiceDef) => ServiceDef;
/** Instantiate and bind services to a provided context */
export declare const instantiateServices: <Srvcs extends Services>(services: Srvcs, ctx?: ServiceBaseContext | undefined) => Srvcs;
