export declare const isReadOnly: (obj: any) => any;
export declare const identity: (a: any) => any;
export declare const noop: () => void;
export declare const secs: (s: number) => number;
export declare const mins: (m: number) => number;
export declare const isObject: (obj: any) => boolean;
export declare const isFunction: (fn: any) => boolean;
export declare const isPrimitive: (v: any) => boolean;
export declare const isThenable: (v: any) => any;
export declare const isArray: (arg: any) => arg is any[];
export declare const isString: (v: any) => boolean;
export declare const isProduction: () => boolean;
export declare const getConsole: () => Console | {
    log: () => void;
    warn: () => void;
    error: () => void;
};
export declare const readOnlyTraps: {
    construct(target: any, args: any[]): any;
    get(target: any, prop: any, receiver: any): any;
    set(target: any, prop: any, val: any): any;
};
export declare const readOnly: <T>(target: T, traps?: {
    [k: string]: Function;
}) => T;
export declare type DeepClone<T> = (T extends Function ? never : T extends (number | string | boolean | symbol | null | undefined | Date) ? T : T extends {
    [prop: string]: any;
    toJSON(...args: any[]): infer R;
} ? R : T extends Promise<infer R> ? Promise<DeepClone<R>> : {
    [P in keyof T]: DeepClone<T[P]>;
});
export declare const deepClone: <T extends unknown, R extends DeepClone<T>>(o: T, maxDepth?: number) => R;
