(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.RemoteFunc = f()}})(function(){var define,module,exports;return (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createClient = exports.Client = void 0;
var p_defer_1 = __importDefault(require("p-defer"));
var util_1 = require("./util");
var MAX_BATCH_SIZE_LIMIT = 1000;
/** Generic client */
var Client = /** @class */ (function () {
    function Client(config) {
        if (config === void 0) { config = {}; }
        if (!config.handler) {
            throw new Error('invalid handler');
        }
        this.config = {};
        this.setConfig(config);
        this.isUsingBatch = false;
        this.batchedRequests = [];
        this.batchedRequestsDeferredPromises = [];
        this.requestPromiseDedupeMap = new Map();
    }
    Client.prototype.setConfig = function (config) {
        this.config = __assign({ deduplicate: true, response: util_1.noop }, config);
    };
    Client.prototype.unscheduleBatch = function () {
        clearTimeout(this.batchScheduleTimeout);
        this.batchScheduleTimeout = void 0;
    };
    Client.prototype.scheduleBatch = function (timeout) {
        this.unscheduleBatch();
        var _timeout = Number(timeout);
        var schedule = _timeout >= 0 ? function (fn) { return setTimeout(fn, _timeout); } : function () { return Infinity; };
        this.batchScheduleTimeout = schedule(this.flush.bind(this));
    };
    /** Execute a client request */
    Client.prototype.request = function (source, args, sourceLoc) {
        var _this = this;
        var _a, _b;
        var deduplicate = this.config.deduplicate;
        var idx = this.batchedRequests.length;
        var deferredPromise = (0, p_defer_1.default)();
        var deduplicateKey = source + JSON.stringify(args);
        var existingPromise = this.requestPromiseDedupeMap.get(deduplicateKey);
        var request = {
            index: idx,
            source: source,
            args: args,
            sourceLoc: sourceLoc,
        };
        if (deduplicate && existingPromise) {
            existingPromise.then(deferredPromise.resolve);
            existingPromise.catch(deferredPromise.reject);
        }
        else {
            this.batchedRequests[idx] = request;
            this.batchedRequestsDeferredPromises[idx] = deferredPromise;
            this.requestPromiseDedupeMap.set(deduplicateKey, deferredPromise.promise);
        }
        if (this.isUsingBatch) {
            var sizeLimit = Math.min(Number((_a = this.batchConfig) === null || _a === void 0 ? void 0 : _a.sizeLimit), MAX_BATCH_SIZE_LIMIT);
            if (this.batchedRequests.length >= sizeLimit) {
                this.flush();
            }
            else if (this.batchScheduleTimeout === void 0) {
                this.scheduleBatch((_b = this.batchConfig) === null || _b === void 0 ? void 0 : _b.timeout);
            }
        }
        else {
            this.flush();
        }
        return deferredPromise.promise.then(function (result) {
            _this.requestPromiseDedupeMap.delete(deduplicateKey);
            return result;
        }, function (reason) {
            _this.requestPromiseDedupeMap.delete(deduplicateKey);
            throw reason;
        });
    };
    /** Flush batched requests */
    Client.prototype.flush = function () {
        var _this = this;
        this.unscheduleBatch();
        if (this.batchedRequests.length === 0)
            return;
        var handler = this.config.handler;
        var requests = this.batchedRequests;
        var deferredPromises = this.batchedRequestsDeferredPromises;
        // reset
        this.batchedRequests = [];
        this.batchedRequestsDeferredPromises = [];
        var write = function (resp) {
            var _a, _b, _c;
            var index = resp.index;
            var deferredPromise = deferredPromises[index];
            _this.config.response(resp);
            if (resp && resp.error === void 0) {
                deferredPromise.resolve(resp.result);
            }
            else {
                var error = new Error((_a = resp.error) === null || _a === void 0 ? void 0 : _a.message);
                error.name = (_c = (_b = resp.error) === null || _b === void 0 ? void 0 : _b.name) !== null && _c !== void 0 ? _c : 'Error';
                deferredPromise.reject(error);
            }
        };
        var end = function (reason) {
            deferredPromises.forEach(function (d) { return d.reject(reason); });
        };
        handler({
            getRequests: function () {
                return requests;
            },
            write: write,
            end: end,
        });
    };
    /** Turn batch mode on or off */
    Client.prototype.useBatch = function (config) {
        this.flush();
        this.isUsingBatch = !!config;
        config = typeof config === 'boolean' ? {} : config;
        this.batchConfig = __assign({ timeout: -1, sizeLimit: MAX_BATCH_SIZE_LIMIT }, config);
    };
    return Client;
}());
exports.Client = Client;
/** Create client instance */
var createClient = function (config) {
    return new Client(config);
};
exports.createClient = createClient;

},{"./util":7,"p-defer":9}],2:[function(require,module,exports){
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.bind = exports.func = void 0;
var mimic_fn_1 = __importDefault(require("mimic-fn"));
var partial_func_1 = require("../server/partial-func");
var rpc_1 = require("../server/rpc");
var createRemoteFunc = function (source, sourceLoc) {
    var remoteFunction = function () {
        throw new Error('Unbound remote function');
    };
    remoteFunction.isRemoteFunction = true;
    remoteFunction.source = source;
    remoteFunction.bound = false;
    remoteFunction.sourceLoc = sourceLoc;
    return remoteFunction;
};
/** Bind a service to a client in such way that the service can be used outside of a query function through RPC */
var bindServiceRpc = function (client, serviceName) {
    var binds = {};
    return new Proxy({}, {
        get: function (target, prop, receiver) {
            if (!binds.hasOwnProperty(prop)) {
                // binds[prop] = bind(client, func(`async (...args) => ${serviceName}.${prop}(...args)`))
                binds[prop] = bind(client, (0, exports.func)((0, rpc_1.createRpcCommand)(serviceName, prop)));
            }
            return binds[prop];
        }
    });
};
/** Create a new remote function */
var func = function (client, sourceInput, sourceLoc) {
    var _client;
    var _sourceInput;
    var _sourceLoc;
    if (client && client.request) {
        _client = client;
        _sourceInput = sourceInput;
        _sourceLoc = sourceLoc;
    }
    else {
        _client = void 0;
        _sourceInput = client;
        _sourceLoc = sourceInput;
    }
    if (typeof _sourceInput === 'string') {
        _sourceInput = _sourceInput;
    }
    else if (Array.isArray(_sourceInput)) {
        _sourceInput = _sourceInput.join('');
    }
    else if (typeof _sourceInput === 'function') {
        throw new Error("wrong use of 'func', use the bundled babel plugin");
    }
    else {
        throw new Error("wrong use of 'func', unsupported source type");
    }
    var remoteFunc = createRemoteFunc(_sourceInput, _sourceLoc);
    if (_client) {
        return bind(_client, remoteFunc);
    }
    return remoteFunc;
};
exports.func = func;
function bind(client, target) {
    if (!client) {
        throw new Error('Invalid client');
    }
    if (typeof target === 'string') {
        return bindServiceRpc(client, target);
    }
    if (!target || !target.isRemoteFunction) {
        throw new Error('Invalid remote function');
    }
    if (target.bound) {
        throw new Error('Remote function already bound');
    }
    var source = target.source;
    var sourceLoc = target.sourceLoc;
    var boundRemoteFunction = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var _args = (args || []).map(function (arg) {
            if (typeof arg === 'function' && arg.isRemoteFunction) {
                return (0, partial_func_1.createPartialFunc)(arg.source);
            }
            return arg;
        });
        return client.request(source, _args, sourceLoc);
    };
    (0, mimic_fn_1.default)(boundRemoteFunction, target);
    boundRemoteFunction.target = target;
    return boundRemoteFunction;
}
exports.bind = bind;

},{"../server/partial-func":10,"../server/rpc":11,"mimic-fn":8}],3:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.engineHandler = void 0;
/** Create an Client handler that works as a direct link between Client and Engine*/
var engineHandler = function (engine) {
    return function (iface) {
        var getRequests = iface.getRequests, write = iface.write, end = iface.end;
        try {
            var responsePromises = getRequests().map(function (request) {
                var source = request.source, args = request.args, index = request.index;
                var ctx = { source: source, args: args };
                return engine.run(source || '', args, ctx).then(function (result) {
                    write({ index: index, result: result });
                }).catch(function (err) {
                    if (err === void 0) { err = {}; }
                    var name = err.name, message = err.message;
                    write({ index: index, error: { name: name, message: message } });
                });
            });
            Promise.all(responsePromises).then(function () { return end(); }, function () { return end(); });
        }
        catch (err) {
            end(err);
            console.log(err);
        }
    };
};
exports.engineHandler = engineHandler;

},{}],4:[function(require,module,exports){
(function (global){(function (){
"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.httpHandler = void 0;
var json_stream_1 = require("../json-stream");
var supportsWebStreams = (typeof global.ReadableStream !== 'undefined'
    && typeof global.TextDecoder !== 'undefined');
var handleFetchStreamResponse = function (response, write, close) {
    var _a;
    if (response.status === 207) {
        var textDecoder_1 = new TextDecoder();
        var reader_1 = (_a = response.body) === null || _a === void 0 ? void 0 : _a.getReader();
        var readChunk_1 = function (result) {
            if (result.done) {
                close();
            }
            else {
                write(textDecoder_1.decode(result.value));
                reader_1 === null || reader_1 === void 0 ? void 0 : reader_1.read().then(readChunk_1);
            }
        };
        reader_1 === null || reader_1 === void 0 ? void 0 : reader_1.read().then(readChunk_1);
    }
};
var handleFetchNoStreamResponse = function (response, write, close) {
    if (response.status === 207) {
        response.text().then(function (json) {
            write(json);
            close();
        });
    }
};
var handleFetchResponse = (supportsWebStreams
    ? handleFetchStreamResponse
    : handleFetchNoStreamResponse);
/** Create an client HTTP handler that works as a link between Client and HTTP */
var httpHandler = function (_config) {
    if (_config === void 0) { _config = {}; }
    var url = 'http://localhost/';
    var globalFetch;
    if (global && global.location) {
        url = global.location;
        globalFetch = global.fetch;
    }
    var config = __assign({ url: url, fetch: globalFetch }, _config);
    return function (iface) {
        var payload = '';
        var requests = iface.getRequests();
        var write = iface.write, end = iface.end;
        var url = config.url, fetch = config.fetch;
        var headers = {
            'Content-Type': 'text/plain;charset=utf-8',
            'Supports-Web-Streams': supportsWebStreams ? '1' : '0',
        };
        var strigifier = (0, json_stream_1.createStringifier)({
            onData: function (str) { return payload += str; }
        });
        requests.forEach(function (r) { return strigifier.write(r); });
        var parser = (0, json_stream_1.createParser)({
            onData: write,
            onClose: function () { return end(); },
            onError: function (err, str) {
                console.log("".concat(str, " ").concat(err.stack));
            },
        });
        fetch(url, { method: 'POST', headers: headers, body: payload }).then(function (response) {
            handleFetchResponse(response, parser.write, parser.close);
        }).catch(function (err) {
            // TODO: handle network error
            end(err);
            console.log(err);
        });
    };
};
exports.httpHandler = httpHandler;

}).call(this)}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
},{"../json-stream":6}],5:[function(require,module,exports){
"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
__exportStar(require("./func"), exports);
__exportStar(require("./client"), exports);
__exportStar(require("./handlers/http"), exports);
__exportStar(require("./handlers/engine"), exports);
__exportStar(require("./util"), exports);

},{"./client":1,"./func":2,"./handlers/engine":3,"./handlers/http":4,"./util":7}],6:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createStringifier = exports.createParser = void 0;
var NL_DELIMITER = '\n';
var noop = function () { };
/** create a JSON stream parser */
var createParser = function (options) {
    var _a = options.delimiter, delimiter = _a === void 0 ? NL_DELIMITER : _a, _b = options.onData, onData = _b === void 0 ? noop : _b, _c = options.onError, onError = _c === void 0 ? noop : _c, _d = options.onClose, onClose = _d === void 0 ? noop : _d;
    var remaining = '';
    var closed = false;
    var throwIfClosed = function () {
        if (closed)
            throw new Error('Parser closed');
    };
    var handleChunk = function (str) {
        try {
            var data = JSON.parse(str);
            onData(data, str);
        }
        catch (err) {
            onError(err, str);
        }
    };
    return {
        /** Write JSON chunk to parse */
        write: function (partial) {
            throwIfClosed();
            var chunks = String(partial).split(delimiter);
            var lastChunkIdx = chunks.length - 1;
            chunks.forEach(function (chunk, idx) {
                remaining = remaining + chunk;
                if (idx < lastChunkIdx) {
                    handleChunk(remaining);
                    remaining = '';
                }
            });
        },
        /** Close parser */
        close: function () {
            var chunkLen = remaining.trim().length;
            if (chunkLen > 0) {
                handleChunk(remaining);
            }
            onClose(remaining);
        }
    };
};
exports.createParser = createParser;
/** create a JSON stream stringifier */
var createStringifier = function (options) {
    var _a = options.delimiter, delimiter = _a === void 0 ? NL_DELIMITER : _a, _b = options.onData, onData = _b === void 0 ? noop : _b, _c = options.onError, onError = _c === void 0 ? noop : _c, _d = options.onClose, onClose = _d === void 0 ? noop : _d;
    var closed = false;
    var throwIfClosed = function () {
        if (closed)
            throw new Error('Stringifier closed');
    };
    return {
        /** Write object to stringify */
        write: function (data) {
            throwIfClosed();
            try {
                var str = JSON.stringify(data) + delimiter;
                onData(str, data);
            }
            catch (err) {
                onError(err, data);
            }
        },
        /** Close stringifier */
        close: function () {
            onClose();
        }
    };
};
exports.createStringifier = createStringifier;

},{}],7:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.noop = exports.funcUrl = void 0;
/** Transform a RemoteFunction to a URL */
var funcUrl = function (url, rf) {
    var source = rf.source;
    var result = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var urlParam = '';
        var hasQuestionChar = url.indexOf('?') !== -1;
        var lastChar = url.charAt(url.length - 1);
        if (lastChar === '?' || lastChar === '&') {
            urlParam = 'requests=';
        }
        else if (!hasQuestionChar) {
            urlParam = '?requests=';
        }
        return url + urlParam + encodeURIComponent(JSON.stringify({ source: source, args: args }));
    };
    return result;
};
exports.funcUrl = funcUrl;
var noop = function () { };
exports.noop = noop;

},{}],8:[function(require,module,exports){
'use strict';

const copyProperty = (to, from, property, ignoreNonConfigurable) => {
	// `Function#length` should reflect the parameters of `to` not `from` since we keep its body.
	// `Function#prototype` is non-writable and non-configurable so can never be modified.
	if (property === 'length' || property === 'prototype') {
		return;
	}

	// `Function#arguments` and `Function#caller` should not be copied. They were reported to be present in `Reflect.ownKeys` for some devices in React Native (#41), so we explicitly ignore them here.
	if (property === 'arguments' || property === 'caller') {
		return;
	}

	const toDescriptor = Object.getOwnPropertyDescriptor(to, property);
	const fromDescriptor = Object.getOwnPropertyDescriptor(from, property);

	if (!canCopyProperty(toDescriptor, fromDescriptor) && ignoreNonConfigurable) {
		return;
	}

	Object.defineProperty(to, property, fromDescriptor);
};

// `Object.defineProperty()` throws if the property exists, is not configurable and either:
//  - one its descriptors is changed
//  - it is non-writable and its value is changed
const canCopyProperty = function (toDescriptor, fromDescriptor) {
	return toDescriptor === undefined || toDescriptor.configurable || (
		toDescriptor.writable === fromDescriptor.writable &&
		toDescriptor.enumerable === fromDescriptor.enumerable &&
		toDescriptor.configurable === fromDescriptor.configurable &&
		(toDescriptor.writable || toDescriptor.value === fromDescriptor.value)
	);
};

const changePrototype = (to, from) => {
	const fromPrototype = Object.getPrototypeOf(from);
	if (fromPrototype === Object.getPrototypeOf(to)) {
		return;
	}

	Object.setPrototypeOf(to, fromPrototype);
};

const wrappedToString = (withName, fromBody) => `/* Wrapped ${withName}*/\n${fromBody}`;

const toStringDescriptor = Object.getOwnPropertyDescriptor(Function.prototype, 'toString');
const toStringName = Object.getOwnPropertyDescriptor(Function.prototype.toString, 'name');

// We call `from.toString()` early (not lazily) to ensure `from` can be garbage collected.
// We use `bind()` instead of a closure for the same reason.
// Calling `from.toString()` early also allows caching it in case `to.toString()` is called several times.
const changeToString = (to, from, name) => {
	const withName = name === '' ? '' : `with ${name.trim()}() `;
	const newToString = wrappedToString.bind(null, withName, from.toString());
	// Ensure `to.toString.toString` is non-enumerable and has the same `same`
	Object.defineProperty(newToString, 'name', toStringName);
	Object.defineProperty(to, 'toString', {...toStringDescriptor, value: newToString});
};

const mimicFn = (to, from, {ignoreNonConfigurable = false} = {}) => {
	const {name} = to;

	for (const property of Reflect.ownKeys(from)) {
		copyProperty(to, from, property, ignoreNonConfigurable);
	}

	changePrototype(to, from);
	changeToString(to, from, name);

	return to;
};

module.exports = mimicFn;

},{}],9:[function(require,module,exports){
'use strict';

const pDefer = () => {
	const deferred = {};

	deferred.promise = new Promise((resolve, reject) => {
		deferred.resolve = resolve;
		deferred.reject = reject;
	});

	return deferred;
};

module.exports = pDefer;

},{}],10:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createPartialFunc = exports.getPartialFuncSource = exports.isPartialFunc = void 0;
var partialFuncKeyworkd = '@partial-func';
var isPartialFunc = function (str) {
    return str.indexOf(partialFuncKeyworkd) === 0;
};
exports.isPartialFunc = isPartialFunc;
/** return partial func source */
var getPartialFuncSource = function (partialFuncCommandStr) {
    return partialFuncCommandStr.substring(partialFuncKeyworkd.length).trim();
};
exports.getPartialFuncSource = getPartialFuncSource;
/** Create partialFunc command */
var createPartialFunc = function (source) {
    return "".concat(partialFuncKeyworkd, " ").concat(source);
};
exports.createPartialFunc = createPartialFunc;

},{}],11:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createRpcCommand = exports.parseRpcCommand = exports.isRpcCommand = void 0;
var rpcKeyworkd = '@rpc';
var rpcTargetSeparator = '.';
var isRpcCommand = function (source) {
    return source.indexOf(rpcKeyworkd) === 0;
};
exports.isRpcCommand = isRpcCommand;
/** Parse rpc command */
var parseRpcCommand = function (rpcCommandStr) {
    var target = rpcCommandStr.substring(rpcKeyworkd.length).trim();
    var splitted = target.split(rpcTargetSeparator);
    return {
        service: splitted[0],
        method: splitted[1],
    };
};
exports.parseRpcCommand = parseRpcCommand;
/** Create rpc command */
var createRpcCommand = function (service, method) {
    return "".concat(rpcKeyworkd, " ").concat(service).concat(rpcTargetSeparator).concat(method);
};
exports.createRpcCommand = createRpcCommand;

},{}]},{},[5])(5)
});
